﻿using Infragistics.Controls.Menus;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace WrapTextApp
{
        public class WidthConverter : IMultiValueConverter
        {
            const double LEVEL_INDENT = 21;
            public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
            {
                double treeWidth = (double)values[0];
                double indentation = (double)values[1];
                double scrollbar = 45;
                double parentIndent = 0;

                XamDataTreeNode node = values[2] as XamDataTreeNode;

                // Use reflection to get ChildNodesManager to get level of tree to determine property space for indentation

                NodesManager nm = (NodesManager)node.GetType().GetProperty("ChildNodesManager", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance).GetValue(node, null); ;


                if (nm != null)
                {
                    parentIndent = LEVEL_INDENT * nm.Level;
                }

                return treeWidth - indentation - scrollbar - parentIndent;
            }

            public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
            {
                throw new NotImplementedException();
            }
        } 
}
